/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _CRYPT_H
#define _CRYPT_H
#ident	"@(#)crypt.h	1.3"

#define X_ENCRYPT	   0
#define X_DECRYPT	  01

#define X_ECB		   0
#define	X_CBC		 010
#define X_OFM		 020
#define	X_CFB		 040
#define X_MODES		 070

#define X_DES		0000
#define X_ENIGMA	0100
#define X_ALGORITHM	0700

#ifdef __cplusplus
extern "C" {
#endif

extern char	*crypt(const char *, const char *);
extern char	*bigcrypt(const char *, const char *);
extern int	crypt_close(int *);
extern char	*des_crypt(const char *, const char *);
extern void	des_encrypt(char *, int);
extern void	des_setkey(const char *);
extern void	encrypt(char *, int);
extern int	run_crypt(long, char *, unsigned, int *);
extern int	run_setkey(int *, const char *);
extern void	setkey(const char *);

extern void	enigma_setkey(const char *);
extern void	enigma_encrypt(char *, int);

extern void	cryptbuf(char *, unsigned, char *, char *, int);

#ifdef __cplusplus
}
#endif

#endif	/* _CRYPT_H */

