/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _CTYPE_H
#define _CTYPE_H
#ident	"@(#)sgs-head:common/head/ctype.h	1.18.2.4"

#ifndef _U
#   define	_U	01	/* Upper case */
#   define	_L	02	/* Lower case */
#   define	_N	04	/* Numeral (digit) */
#   define	_S	010	/* Spacing character */
#   define	_P	020	/* Punctuation */
#   define	_C	040	/* Control character */
#   define	_B	0100	/* Blank */
#   define	_X	0200	/* heXadecimal digit */
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int	isalnum(int);
extern int	isalpha(int);
extern int	iscntrl(int);
extern int	isdigit(int);
extern int	isgraph(int);
extern int	islower(int);
extern int	isprint(int);
extern int	ispunct(int);
extern int	isspace(int);
extern int	isupper(int);
extern int	isxdigit(int);
extern int	tolower(int);
extern int	toupper(int);

extern int	isascii(int);
extern int	toascii(int);
extern int	_tolower(int);
extern int	_toupper(int);

extern unsigned char	__ctype[];

#ifdef __cplusplus
}
#endif

#if !#lint(on)

#define	isalnum(c)	((__ctype + 1)[c] & (_U | _L | _N))
#define	isalpha(c)	((__ctype + 1)[c] & (_U | _L))
#define	iscntrl(c)	((__ctype + 1)[c] & _C)
#define	isdigit(c)	((__ctype + 1)[c] & _N)
#define	isgraph(c)	((__ctype + 1)[c] & (_P | _U | _L | _N))
#define	islower(c)	((__ctype + 1)[c] & _L)
#define	isprint(c)	((__ctype + 1)[c] & (_P | _U | _L | _N | _B))
#define	ispunct(c)	((__ctype + 1)[c] & _P)
#define	isspace(c)	((__ctype + 1)[c] & _S)
#define	isupper(c)	((__ctype + 1)[c] & _U)
#define	isxdigit(c)	((__ctype + 1)[c] & _X)

#define	isascii(c)	(!((c) & ~0177))
#define	toascii(c)	((c) & 0177)

#if defined(_XOPEN_SOURCE) || (__STDC__ - 0 == 0 \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE))
#define	_tolower(c)	((__ctype + 258)[c])
#define	_toupper(c)     ((__ctype + 258)[c])
#endif

#endif /*lint*/

#endif /*_CTYPE_H*/
