/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _GRP_H
#define _GRP_H
#ident	"@(#)sgs-head:common/head/grp.h	1.3.5.9"

#include <sys/types.h>

struct group
{
	char	*gr_name;
	char	*gr_passwd;
	gid_t	gr_gid;
	char	**gr_mem;
};

#ifdef __cplusplus
extern "C" {
#endif

struct group	*getgrgid(gid_t);
struct group	*getgrnam(const char *);

#if !defined(_XOPEN_SOURCE) \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)

struct _FILE_;
extern void	endgrent(void);
struct group	*fgetgrent(struct _FILE_ *);
struct group	*getgrent(void);
extern void	setgrent(void);
extern int	initgroups(const char *, gid_t);
extern int	getgrgid_r(gid_t, struct group *, char *, size_t, struct group **);
extern int	getgrnam_r(const char *, struct group *, char *, size_t, struct group **);

#elif defined(_XOPEN_SOURCE) && _XOPEN_SOURCE_EXTENDED - 0 >= 1

extern void	endgrent(void);
struct group	*getgrent(void);
extern void	setgrent(void);

#elif _POSIX_C_SOURCE - 0 >= 199506

extern int	getgrgid_r(gid_t, struct group *, char *, size_t, struct group **);
extern int	getgrnam_r(const char *, struct group *, char *, size_t, struct group **);

#endif /*!defined(_XOPEN_SOURCE) && ...*/

#ifdef __cplusplus
}
#endif

#endif /*_GRP_H*/
