/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _MALLOC_H
#define _MALLOC_H
#ident	"@(#)sgs-head:common/head/malloc.h	1.10"

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int       size_t;
#endif

#define M_MXFAST	1 /* set size of blocks to be fast */
#define M_NLBLKS	2 /* set number of block in a holding block */
#define M_GRAIN		3 /* set allocation granularity for small blocks */
#define M_KEEP		4 /* free preserves block contents until allocation */
/*
	structure filled by 
*/
#ifndef _MALLINFO
#define _MALLINFO
struct mallinfo  {
	size_t	arena;		/* total space in arena */
	size_t	ordblks;	/* number of ordinary blocks */
	size_t	smblks;		/* number of small blocks */
	size_t	hblks;		/* number of holding blocks */
	size_t	hblkhd;		/* space in holding block headers */
	size_t	usmblks;	/* space in small blocks in use */
	size_t	fsmblks;	/* space in free small blocks */
	size_t	uordblks;	/* space in ordinary blocks in use */
	size_t	fordblks;	/* space in free ordinary blocks */
	size_t	keepcost;	/* (OBSOLETE) cost of enabling keep option */
};	
#endif

extern void	*malloc(size_t);
extern void	free(void *);
extern void	*realloc(void *, size_t);
extern int	mallopt(int, int);	/* OBSOLETE */
struct mallinfo	mallinfo(void);
extern void	*calloc(size_t, size_t);

#endif /*_MALLOC_H*/
