/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef PANEL_H
#define PANEL_H
#ident	"@(#)libeti:panel/panel.h	1.5.1.1"

#include <curses.h>

typedef struct _obscured_list
	{
		struct PANEL	*panel_p;
		int	start, end;
		struct _obscured_list	*next;
	} _obscured_list;

typedef struct PANEL
	{
		WINDOW	*win;
		int	wstarty;
		int	wendy;
		int	wstartx;
		int	wendx;
		struct _obscured_list	*obscured;
		struct PANEL	*below, *above;
		char	*user;
	} PANEL;

#ifdef __cplusplus
extern "C" {
#endif

extern PANEL	*new_panel(WINDOW *);
extern int	del_panel(PANEL *);
extern int	hide_panel(PANEL *);
extern int	show_panel(PANEL *);
extern int	panel_hidden(PANEL *);
extern int	move_panel(PANEL *, int, int);
extern int	replace_panel(PANEL *, WINDOW *);
extern int	top_panel(PANEL *);
extern int	bottom_panel(PANEL *);
extern void	update_panels(void);
extern WINDOW	*panel_window(PANEL *);
extern int	set_panel_userptr(PANEL *, char *);
extern char	*panel_userptr(PANEL *);
extern PANEL	*panel_above(PANEL *);
extern PANEL	*panel_below(PANEL *);

#ifdef __cplusplus
}
#endif

#endif /* PANEL_H */
