/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _SIGINFO_H
#define _SIGINFO_H
#ident	"@(#)sgs-head:common/head/siginfo.h	1.7"

#include <sys/types.h>
#include <sys/siginfo.h>

union sigval {
	int	sival_int;	/* integer value */
	void	*sival_ptr;	/* pointer value */
};

union notifyinfo {
	int		nisigno;	/* signal number */
	void		(*nifunc)(union sigval);
};

struct sigevent {
	int		sigev_notify;	/* notification mode */
	union notifyinfo sigev_notifyinfo; 
	union sigval	sigev_value;	/* signal value */
};
#define	sigev_func	sigev_notifyinfo.nifunc
#define sigev_signo	sigev_notifyinfo.nisigno

/* values of sigev_notify */
#define	SIGEV_NONE	1	/* no notification required */
#define	SIGEV_SIGNAL	2	/* queued signal notification */
#define	SIGEV_CALLBACK	3	/* call back notification */

#ifdef __cplusplus
extern "C" {
#endif

extern void	psiginfo(const siginfo_t *, const char *);
extern void	psignal(int, const char *);

#ifdef __cplusplus
}
#endif

#endif /*_SIGINFO_H*/
