/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _SIGNAL_H
#define _SIGNAL_H
#ident	"@(#)sgs-head:common/head/signal.h	1.5.6.8"

#include <sys/signal.h>
#include <sys/types.h>

typedef int 	sig_atomic_t;

#ifdef __cplusplus
extern "C" {
#endif

extern const char *const	_sys_siglist[];
extern const int		_sys_nsig;

extern void	(*signal(int, void (*)(int)))(int);
extern int	raise(int);

#if __STDC__ - 0 == 0 || defined(_XOPEN_SOURCE) \
	|| defined(_POSIX_SOURCE) || defined(_POSIX_C_SOURCE)

extern int	kill(pid_t, int);
extern int	sigaction(int, const struct sigaction *, struct sigaction *);
extern int	sigaddset(sigset_t *, int);
extern int	sigdelset(sigset_t *, int);
extern int	sigemptyset(sigset_t *);
extern int	sigfillset(sigset_t *);
extern int	sigismember(const sigset_t *, int);
extern int	sigpending(sigset_t *);
extern int	sigprocmask(int, const sigset_t *, sigset_t *);
extern int	sigsuspend(const sigset_t *);

#endif /*__STDC__ - 0 == 0 || ...*/

#if __STDC__ - 0 == 0 && !defined(_XOPEN_SOURCE) \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)

#include <sys/procset.h>

extern void	(*bsd_signal(int , void (*) (int)))(int);
extern int	gsignal(int);
extern int	killpg(pid_t, int);
extern void	(*sigset(int, void (*)(int)))(int);
extern int	sighold(int);
extern int	sigrelse(int);
extern int	sigignore(int);
extern int 	siginterrupt(int, int);
extern int	sigpause(int);
extern int	(*ssignal(int, int (*)(int)))(int);
extern int	sigaltstack(const stack_t *, stack_t *);
extern int	sigsend(idtype_t, id_t, int);
extern int	sigsendset(const procset_t *, int);
extern int	sigstack(struct sigstack *, struct sigstack *);
extern int	sigwait(sigset_t *);

#elif defined(_XOPEN_SOURCE) && _XOPEN_SOURCE_EXTENDED - 0 >= 1

extern void	(*bsd_signal(int , void (*) (int)))(int); 
extern int	killpg(pid_t, int);
extern int	sigaltstack(const stack_t *, stack_t *);
extern int	sighold(int);
extern int	sigignore(int);
extern int 	siginterrupt(int, int);
extern int	sigpause(int);
extern int	sigrelse(int);
extern void	(*sigset(int, void (*)(int)))(int);
extern int	sigstack(struct sigstack *, struct sigstack *);

#endif /*__STDC__ - 0 == 0 && ...*/

#ifdef __cplusplus
}
#endif

#endif /*_SIGNAL_H*/
