/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _STRINGS_H
#define _STRINGS_H
#ident	"@(#)sgs-head:common/head/strings.h	1.4"

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int size_t;
#endif

#ifdef __cplusplus
extern "C" {
#endif

int 	bcmp(const void *, const void *, size_t);
void 	bcopy(const void *, void *, size_t );
void 	bzero(void *, size_t);
int 	ffs(int);
char 	*index(const char *, int);
char 	*rindex(const char *, int);
int 	strcasecmp(const char *, const char *);
int 	strncasecmp(const char *, const char *, size_t);

#if !defined(_XOPEN_SOURCE) || _XOPEN_SOURCE_EXTENDED - 0 < 1

#include <string.h>

#define bcmp(s1, s2, len)	memcmp(s1, s2, len)
#define bcopy(s1, s2, len)	(void)memmove(s2, s1, len)
#define bzero(s1, len)		(void)memset(s1, 0, len)
#define index(sp, c)		strchr(sp, c)
#define rindex(sp, c)		strrchr(sp, c)

#endif

#ifdef __cplusplus
}
#endif

#endif /*_STRINGS_H*/
